#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "exit.h"
#include "getoptb.h"

#define WHO "b64decode"

stralloc line = {0};
stralloc temp = {0};
stralloc out = {0};
int match;

int main(int argc,char **argv)
{
  int r;
  int opt;
  int flag = 0;

  while ((opt = getoptb(argc,argv,"u")) != opteof)
     switch (opt) {
       case 'u': flag = 4648; break;
       default : logmsg(WHO,100,USAGE,"b64decode [-u] (reading from STDIN)");
     }

  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,B("unable to read input: ",line.s));
    if (!stralloc_cat(&temp,&line)) _exit(-1);
    if (!match) break;
  }

  if (flag == 4648) r = mess822_b64decode(&out,temp.s,temp.len,4648);
  else r = mess822_b64decode(&out,temp.s,temp.len,1);
  if (r > 0) buffer_put(buffer_1,out.s,out.len);
  buffer_flush(buffer_1);

  _exit(0);
}
