#include "buffer.h"
#include "logmsg.h"
#include "getln.h"
#include "mess822.h"
#include "exit.h"

#define WHO "qpencode"

stralloc line = {0};
stralloc out = {0};
int match;

int main()
{
  for (;;) {
    if (getln(buffer_0,&line,&match,'\n') == -1)
      logmsg(WHO,111,FATAL,B("unable to read input: ",line.s));

    if (!stralloc_0(&line)) return -1;
    if (mess822_qpencode(&out,&line) > 0)
      buffer_put(buffer_1,out.s,out.len);
    if (!match) break;
  }

  buffer_flush(buffer_1);
  _exit(0);
}
